package com.sun.jmx.snmp.agent;

import javax.management.RuntimeOperationsException;
import javax.management.NotCompliantMBeanException;
import javax.management.MBeanRegistrationException;
import javax.management.InstanceAlreadyExistsException;
import com.sun.jmx.snmp.SnmpOid;
import javax.management.InvalidAttributeValueException;
import javax.management.MBeanException;
import com.sun.jmx.snmp.SnmpValue;
import java.util.Iterator;
import java.util.Enumeration;
import javax.management.Attribute;
import javax.management.ReflectionException;
import javax.management.InstanceNotFoundException;
import javax.management.AttributeList;
import com.sun.jmx.snmp.SnmpStatusException;
import com.sun.jmx.snmp.SnmpVarBind;
import javax.management.ObjectName;
import javax.management.MBeanServer;

public class SnmpGenericObjectServer
{
    protected final MBeanServer server;
    
    public SnmpGenericObjectServer(MBeanServer server) {
        this.server = server;
    }
    
    public void get(SnmpGenericMetaServer snmpGenericMetaServer, ObjectName objectName, SnmpMibSubRequest snmpMibSubRequest, int n) throws SnmpStatusException {
        int size = snmpMibSubRequest.getSize();
        Object userData = snmpMibSubRequest.getUserData();
        String[] array = new String[size];
        SnmpVarBind[] array2 = new SnmpVarBind[size];
        long[] array3 = new long[size];
        int n2 = 0;
        Enumeration<SnmpVarBind> elements = snmpMibSubRequest.getElements();
        while (elements.hasMoreElements()) {
            SnmpVarBind snmpVarBind = (SnmpVarBind)elements.nextElement();
            try {
                long oidArc = snmpVarBind.oid.getOidArc(n);
                array[n2] = snmpGenericMetaServer.getAttributeName(oidArc);
                array2[n2] = snmpVarBind;
                snmpGenericMetaServer.checkGetAccess(array3[n2] = oidArc, userData);
                ++n2;
            }
            catch (SnmpStatusException ex) {
                snmpMibSubRequest.registerGetException(snmpVarBind, ex);
            }
        }
        int n3 = 224;
        AttributeList attributes;
        try {
            attributes = this.server.getAttributes(objectName, array);
        }
        catch (InstanceNotFoundException ex2) {
            attributes = new AttributeList();
        }
        catch (ReflectionException ex3) {
            attributes = new AttributeList();
        }
        catch (Exception ex4) {
            attributes = new AttributeList();
        }
        Iterator<Object> iterator = attributes.iterator();
        for (int i = 0; i < n2; ++i) {
            if (!iterator.hasNext()) {
                snmpMibSubRequest.registerGetException(array2[i], new SnmpStatusException(n3));
            }
            else {
                Attribute attribute;
                for (attribute = (Attribute)iterator.next(); i < n2 && !array[i].equals(attribute.getName()); ++i) {
                    snmpMibSubRequest.registerGetException(array2[i], new SnmpStatusException(n3));
                }
                if (i == n2) {
                    break;
                }
                try {
                    array2[i].value = snmpGenericMetaServer.buildSnmpValue(array3[i], attribute.getValue());
                }
                catch (SnmpStatusException ex5) {
                    snmpMibSubRequest.registerGetException(array2[i], ex5);
                }
            }
        }
    }
    
    public SnmpValue get(SnmpGenericMetaServer snmpGenericMetaServer, ObjectName objectName, long n, Object o) throws SnmpStatusException {
        String attributeName = snmpGenericMetaServer.getAttributeName(n);
        Object attribute;
        try {
            attribute = this.server.getAttribute(objectName, attributeName);
        }
        catch (MBeanException ex) {
            Exception targetException = ex.getTargetException();
            if ((targetException instanceof SnmpStatusException)) {
                throw (SnmpStatusException)targetException;
            }
            throw new SnmpStatusException(224);
        }
        catch (Exception ex2) {
            throw new SnmpStatusException(224);
        }
        return snmpGenericMetaServer.buildSnmpValue(n, attribute);
    }
    
    public void set(SnmpGenericMetaServer snmpGenericMetaServer, ObjectName objectName, SnmpMibSubRequest snmpMibSubRequest, int n) throws SnmpStatusException {
        int size = snmpMibSubRequest.getSize();
        AttributeList list = new AttributeList(size);
        String[] array = new String[size];
        SnmpVarBind[] array2 = new SnmpVarBind[size];
        long[] array3 = new long[size];
        int n2 = 0;
        Enumeration<SnmpVarBind> elements = snmpMibSubRequest.getElements();
        while (elements.hasMoreElements()) {
            SnmpVarBind snmpVarBind = (SnmpVarBind)elements.nextElement();
            try {
                long oidArc = snmpVarBind.oid.getOidArc(n);
                String attributeName = snmpGenericMetaServer.getAttributeName(oidArc);
                list.add(new Attribute(attributeName, snmpGenericMetaServer.buildAttributeValue(oidArc, snmpVarBind.value)));
                array[n2] = attributeName;
                array2[n2] = snmpVarBind;
                array3[n2] = oidArc;
                ++n2;
            }
            catch (SnmpStatusException ex) {
                snmpMibSubRequest.registerSetException(snmpVarBind, ex);
            }
        }
        int n3 = 6;
        AttributeList setAttributes;
        try {
            setAttributes = this.server.setAttributes(objectName, list);
        }
        catch (InstanceNotFoundException ex2) {
            setAttributes = new AttributeList();
            n3 = 18;
        }
        catch (ReflectionException ex3) {
            n3 = 18;
            setAttributes = new AttributeList();
        }
        catch (Exception ex4) {
            setAttributes = new AttributeList();
        }
        Iterator<Object> iterator = setAttributes.iterator();
        for (int i = 0; i < n2; ++i) {
            if (!iterator.hasNext()) {
                snmpMibSubRequest.registerSetException(array2[i], new SnmpStatusException(n3));
            }
            else {
                Attribute attribute;
                for (attribute = (Attribute)iterator.next(); i < n2 && !array[i].equals(attribute.getName()); ++i) {
                    snmpMibSubRequest.registerSetException(array2[i], new SnmpStatusException(6));
                }
                if (i == n2) {
                    break;
                }
                try {
                    array2[i].value = snmpGenericMetaServer.buildSnmpValue(array3[i], attribute.getValue());
                }
                catch (SnmpStatusException ex5) {
                    snmpMibSubRequest.registerSetException(array2[i], ex5);
                }
            }
        }
    }
    
    public SnmpValue set(SnmpGenericMetaServer snmpGenericMetaServer, ObjectName objectName, SnmpValue snmpValue, long n, Object o) throws SnmpStatusException {
        String attributeName = snmpGenericMetaServer.getAttributeName(n);
        Attribute attribute = new Attribute(attributeName, snmpGenericMetaServer.buildAttributeValue(n, snmpValue));
        Object attribute2;
        try {
            this.server.setAttribute(objectName, attribute);
            attribute2 = this.server.getAttribute(objectName, attributeName);
        }
        catch (InvalidAttributeValueException ex) {
            throw new SnmpStatusException(10);
        }
        catch (InstanceNotFoundException ex2) {
            throw new SnmpStatusException(18);
        }
        catch (ReflectionException ex3) {
            throw new SnmpStatusException(18);
        }
        catch (MBeanException ex4) {
            Exception targetException = ex4.getTargetException();
            if ((targetException instanceof SnmpStatusException)) {
                throw (SnmpStatusException)targetException;
            }
            throw new SnmpStatusException(6);
        }
        catch (Exception ex5) {
            throw new SnmpStatusException(6);
        }
        return snmpGenericMetaServer.buildSnmpValue(n, attribute2);
    }
    
    public void check(SnmpGenericMetaServer snmpGenericMetaServer, ObjectName objectName, SnmpMibSubRequest snmpMibSubRequest, int n) throws SnmpStatusException {
        Object userData = snmpMibSubRequest.getUserData();
        Enumeration<SnmpVarBind> elements = snmpMibSubRequest.getElements();
        while (elements.hasMoreElements()) {
            SnmpVarBind snmpVarBind = (SnmpVarBind)elements.nextElement();
            try {
                this.check(snmpGenericMetaServer, objectName, snmpVarBind.value, snmpVarBind.oid.getOidArc(n), userData);
            }
            catch (SnmpStatusException ex) {
                snmpMibSubRequest.registerCheckException(snmpVarBind, ex);
            }
        }
    }
    
    public void check(SnmpGenericMetaServer snmpGenericMetaServer, ObjectName objectName, SnmpValue snmpValue, long n, Object o) throws SnmpStatusException {
        snmpGenericMetaServer.checkSetAccess(snmpValue, n, o);
        try {
            String attributeName = snmpGenericMetaServer.getAttributeName(n);
            Object buildAttributeValue = snmpGenericMetaServer.buildAttributeValue(n, snmpValue);
            Object[] array = { null };
            String[] array2 = { null };
            array[0] = buildAttributeValue;
            array2[0] = buildAttributeValue.getClass().getName();
            this.server.invoke(objectName, "check" + attributeName, array, array2);
        }
        catch (SnmpStatusException ex) {
            throw ex;
        }
        catch (InstanceNotFoundException ex2) {
            throw new SnmpStatusException(18);
        }
        catch (ReflectionException ex3) {}
        catch (MBeanException ex4) {
            Exception targetException = ex4.getTargetException();
            if ((targetException instanceof SnmpStatusException)) {
                throw (SnmpStatusException)targetException;
            }
            throw new SnmpStatusException(6);
        }
        catch (Exception ex5) {
            throw new SnmpStatusException(6);
        }
    }
    
    public void registerTableEntry(SnmpMibTable snmpMibTable, SnmpOid snmpOid, ObjectName objectName, Object o) throws SnmpStatusException {
        if (objectName == null) {
            throw new SnmpStatusException(18);
        }
        try {
            if (o != null && !this.server.isRegistered(objectName)) {
                this.server.registerMBean(o, objectName);
            }
        }
        catch (InstanceAlreadyExistsException ex) {
            throw new SnmpStatusException(18);
        }
        catch (MBeanRegistrationException ex2) {
            throw new SnmpStatusException(6);
        }
        catch (NotCompliantMBeanException ex3) {
            throw new SnmpStatusException(5);
        }
        catch (RuntimeOperationsException ex4) {
            throw new SnmpStatusException(5);
        }
        catch (Exception ex5) {
            throw new SnmpStatusException(5);
        }
        return;
    }
}
